# -*- coding: utf-8 -*-
from setuptools import setup

package_dir = \
{'': 'src'}

packages = \
['parboil']

package_data = \
{'': ['*']}

install_requires = \
['Jinja2>=3.0.2,<4.0.0',
 'click>=8.0.3,<9.0.0',
 'jinja2-ansible-filters>=1.3.2,<2.0.0',
 'jsoncparser>=1.0.4,<2.0.0',
 'rich>=12.6.0,<13.0.0']

entry_points = \
{'console_scripts': ['boil = parboil.parboil:boil']}

setup_kwargs = {
    'name': 'parboil',
    'version': '0.9.2',
    'description': 'Create reusable boilerplate templates to kickstart your next project.',
    'long_description': '# :rice: Parboil\n\n**Project Boilerplate Generator**\n\n![GitHub](https://img.shields.io/github/license/jneug/parboil)\n\nWith _Parboil_ you can create reusable boilerplate templates to kickstart your next project.\n\n!!! note ""\n\n\t_Parboil_ is a Python rewrite of [boilr](https://github.com/tmrts/boilr) by [Tamer Tas](https://github.com/tmrts)\n\n----\n\n<div data-termynal-container>\n    <div id="termynal" data-termynal data-ty-typeDelay="40" data-ty-lineDelay="1500">\n        <span data-ty="input">pipx install parboil</span>\n        <span data-ty="progress"></span>\n        <span data-ty-delay="0" data-ty>Successfully installed parboil</span>\n        <span data-ty-delay="0" data-ty></span>\n        <span data-ty="input" data-ty-delay="1800">boil install -d jneug/parboil-license</span>\n        <span data-ty-delay="0" data-ty>[<span class="ty-success">✓</span>] Installed recipe <span class="ty-recipe">parboil-license</span></span>\n\t\t<span data-ty-delay="0" data-ty>[<span class="ty-info">i</span>]</span>\n    \t<span data-ty-delay="0" data-ty>&nbsp;&nbsp;&nbsp;&nbsp;Use with <span class="ty-cmd">boil use parboil-license</span></span>\n\t\t<span data-ty></span>\n\t\t<span data-ty="input">boil use parboil-license</span>\n\t\t<!-- -->\n\t\t<span data-ty-delay="0" data-ty>[<span class="ty-success">i</span>] Used prefilled value for "<span class="ty-ingredient">Author</span>"</span>\n\t\t<span data-ty-delay="0" data-ty>[<span class="ty-success">i</span>] Used prefilled value for "<span class="ty-ingredient">Email</span>"</span>\n\t\t<!-- -->\n\t\t<span data-ty>[<span class="ty-question">?</span>] Enter a value for "<span class="ty-ingredient">Year</span>" <span class="ty-default">(2022)</span>:</span>\n\t\t<!-- -->\n\t\t<span data-ty-delay="0" data-ty>[<span class="ty-question">?</span>] Choose a value for "<span class="ty-ingredient">License</span>"</span>\n\t\t<span data-ty-delay="0" data-ty>&nbsp;&nbsp;&nbsp;&nbsp;<span class="ty-input">1</span> - <span class="ty-keyword">Apache License 2.0</span></span>\n\t\t<span data-ty-delay="0" data-ty>&nbsp;&nbsp;&nbsp;&nbsp;<span class="ty-input">2</span> - <span class="ty-keyword">MIT</span></span>\n\t\t<span data-ty-delay="0" data-ty>&nbsp;&nbsp;&nbsp;&nbsp;<span class="ty-input">3</span> - <span class="ty-keyword">ISC</span></span>\n\t\t<span data-ty-delay="0" data-ty>&nbsp;&nbsp;&nbsp;&nbsp;<span class="ty-input">4</span> - <span class="ty-keyword">GNU GPL v3.0</span></span>\n\t\t<span data-ty-delay="0" data-ty>&nbsp;&nbsp;&nbsp;&nbsp;<span class="ty-input">5</span> - <span class="ty-keyword">GNU GPL v2.0</span></span>\n\t\t<span data-ty-delay="0" data-ty>&nbsp;&nbsp;&nbsp;&nbsp;<span class="ty-input">6</span> - <span class="ty-keyword">CC-BY 4.0</span></span>\n\t\t<span data-ty-delay="0" data-ty>&nbsp;&nbsp;&nbsp;&nbsp;<span class="ty-input">7</span> - <span class="ty-keyword">CC-BY-SA 4.0</span></span>\n\t\t<span data-ty-delay="0" data-ty>&nbsp;&nbsp;&nbsp;&nbsp;<span class="ty-input">8</span> - <span class="ty-keyword">CC-0 1.0</span></span>\n\t\t<span data-ty-delay="0" data-ty>&nbsp;&nbsp;&nbsp;&nbsp;Select from <span class="ty-input">1..9</span></span>\n\t\t<span data-ty="input">2</span>\n\t\t<!-- -->\n\t\t<span data-ty>[<span class="ty-success">i</span>] Generated project for recipe "<span class="ty-recipe">parboil-license</span>" in <span class="ty-path">/Users/xyz/Projects/foo</span></span>\n    </div>\n</div>\n\n## Installation\n\nInstall **Python 3** and then _Parboil_ with **pip**:\n\n```\npip install parboil\n```\n\n_Parboil_ will install a `boil` command on your system. Run `boil --version` to see, if it worked.\n\n## Getting started\n\nUse `boil --help` to see the list of [available commands](overview.md) and `boil <command> --help` to see usage information for any command.\n\n### Installing your first template\n\n_Parboil_ maintains a local repository of project templates. To use _Parboil_ you first need to install a template. You can install templates from a local directory or download them from GitHub.\n\nFor your first template install `jneug/parboil-template` from GitHub - a project template to create parboil project templates.\n\n```\nboil install -d jneug/parboil-template pbt\n```\n\nThis will download the template from [`jneug/parboil-template`](https://github.com/jneug/parboil-template) and makes it available under the name `pbt`. (The `-d` flag tells Parboil, that you want to download from GitHub and not from a local directory.)\n\nVerify the install with `boil list`.\n\n### Using a template\n\nTo use your new template run\n\n```\nboil use pbt new_template\n```\n\nThis will create the boilerplate project in the `new_template` directory. (Omitting the directory will add the template to the current working dir.) _Parboil_ asks you to input some data and then writes the project files.\n\n### Uninstall and update\n\nTo remove a template run `boil uninstall <templatename>` and to update from its original source (either a local directory or a GitHub repository) run `boil update <templatename>`. \n\n### Creating your first recipe\n\nThe `parboil-template` is a good starting point to create your own template. _Parboil_ uses [Jinja2](https://jinja.palletsprojects.com) to parse the template files and dynamically insert the user information into the template files. That means, you can use all of Jinjas features (and some more), to create your template files. \n\nLet\'s create a simple project template for meeting logs from scratch.\n\nFirst, create a directory for your new template. Let\'s call it `meeting_log`. Then creat a directory called `template` and a file called `project.json` in it.\n\n```\nmeeting_log/\n├── template/\n└── parboil.json\n```\n\nThis is the basic structure of a parboil recipe. `parboil.json` holds the recipe configuration and `template` the actual template files.\n\nNow open `parboil.json` in any editor and copy the following text into it:\n\n!!! example\n\n\t``` json\n\t{\n\t\t// Ingredients for the meeting log recipe\n\t\t"Author": "",\n\t\t"Meeting": "Daily meeting",\n\t\t"MeetingNo": 1,\n\t\t"Topic": "Planning the day",\n\t\t"IamModerator": false,\n\t\t"NumberOfTops": 2\n\t}\n\t```\n\nThis is a basic recipe that defines five [ingredients](recipes/ingredients.md). Ingredients are essentially variables that are filled in by the user and inserted into the template files. The key of each entry is the field name, the value is the default. An empty string means, the key is required everytime.\n\n!!! tip\n\n\tAs you can see in the example above, a recipe is defined in json with comments format. \n\nNow we need to add the file(s) that should be created by Parboil. Create `{{Meeting}}_log.md` in the `template` directory. And enter this text:\n\n``` jinja\n# Meeting notes for {{ Meeting|title }} #{{ MeetingNo }} \n\n> Date: {% time \'%Y-%m-%d\' %}\n> Topic: {{ Topic }}\n> Author: {{ Author }}\n{% if IamModerator %}> Moderator: {{ Author }}{% endif %}\n\n## Topics\n\n{% for t in range(NumberOfTops) %}\n{{t|format(\'{:<2}\')}}. \n{% endfor %}\n\n## Notes\n\n\n```\n\nThe template uses [Jinjas syntax](https://jinja.palletsprojects.com/en/3.10.x/templates/) to add the field values. For example `{{ Author }}` will be replaced with the name you entered while prompted. Note that you can use the fields in filenames, too.\n\nYou can use any Jinja [macros](https://jinja.palletsprojects.com/en/2.11.x/templates/#list-of-control-structures) and [filters](https://jinja.palletsprojects.com/en/2.11.x/templates/#list-of-builtin-filters) in your templates. `{{ Meeting|title }}` will tranform the value of "Meeting" into titlecase. `{% if IamModerator %}` is a conditional. \n\nFor more information read [the wiki page on template creation](recipes/howto.md).\n\n### Some more template creation\n\nYou can do some more complex stuff with templates. For example you might want to name the logfile in the example above with the current date and the meetings number padded with zeros to two digits. Also, the meeting name should be filtered for use in filenames. You would need to name the file like this:\n\n```\n{% time \'%Y-%m-%d\' }_{{ \'{:02}\'.format(MeetingNo) }}-{{\xa0Meeting|fileify }}.md\n```\n\nThe use of special chars works on many systems, but now all. Also, the filename becomes hard to read.\n\nTo deal with this, you can rename your files from the `project.json` config file. Add a `files` object next to the `fields` and map the filenames to the rename pattern:\n\n\n```\n{\n\t"fields": {\n\t\t...\n\t},\n\t"files": {\n\t\t"meeting-log.md": "{% time \'%Y-%m-%d\' }_{{ \'{:02}\'.format(MeetingNo) }}-{{\xa0Meeting|fileify }}.md"\n\t}\n}\n```\n\nNow you can name the log file `meeting-log.md` and will get something like `2021-03-10_04-Daily Standup.md` as a result.\n\nThere are some more features for creating complex templates, like subtemplates (for example run a template to generate a license file inside differnt app project templates), selective file inclusion, template inheritance or dealing with empty files.\n',
    'author': 'J. Neugebauer',
    'author_email': 'github@neugebauer.cc',
    'maintainer': 'None',
    'maintainer_email': 'None',
    'url': 'http://github.com/jneug/parboil',
    'package_dir': package_dir,
    'packages': packages,
    'package_data': package_data,
    'install_requires': install_requires,
    'entry_points': entry_points,
    'python_requires': '>=3.9,<4.0',
}


setup(**setup_kwargs)
